package Libconf::Glueconf::Wrapper;

sub debug { Libconf::debug(@_) }

#internal function, used by almost all template to fetch things
sub fetch {
    my ($obj, $atompos, $val) = @_;
    $obj->{libconf}{_fetch_atom_pos} and $obj->{libconf}{_atom_pos} = $atompos;
    debug(" ******** atom_pos : $atom_pos");
    my $atom = $obj->{libconf}->get_atom($atompos);
    debug(" ******** atom : $atom");
    ref($val) eq 'CODE' ? $val->($atom) : $atom->{$val};
}

sub check_type {
   my ($obj, $val, $type) = @_;
   ref($val) eq ($type eq 'SCALAR' ? '' : $type) or die "value is not of type $type";
}

#fetch_comments is obsolete
#     if ($obj->{libconf}->{fetch_comments}) {
#         { comments => { map { my ($a, $b) = @$_;
#                               ($a, join("\n", map { $_->{comment} } grep {$_->{inline} == $b} @{$atom->{comments}}))
#                             } ( [normal => 0], [left_inline => -1], [right_inline => 1])
#                       },
#           value => (ref($val) eq 'CODE' ? $val->($atom) : $atom->{$val})
#         }
#     } else {
#         ref($val) eq 'CODE' ? $val->($atom) : $atom->{$val};
#     }
# }
1;
